<template>
  <div class="q-pa-md">
    <div class="row q-col-gutter-md margin-lg" v-if="loaded">
      <div class="col-xs-12 col-sm-6 col-8 q-pa-md">
        <h5 class="text-h5 q-mb-sm text-weight-medium">{{product.name}}</h5>
        <p class="text-body1 text-primary">{{product.price}} RON</p>
        <q-img :src="product.image" style="width: 100%"></q-img>
      </div>
      <div class="col-xs-12 col-sm-6 col-4 q-pa-md">
        <div class="column q-mt-xl">
          <p class="text-weight-medium q-mb-xl">SELECT SIZE</p>
          <div class="row">
            <q-btn
              v-for="size in availableSizes"
              :key="size"
              outline
              class="grid-style-transition"
              :class="selectedSize==size ? 'bg-grey-3' : ''"
              style="color: goldenrod;"
              :style="selectedSize ==size  ? 'transform: scale(0.95);' : ''"
              :label="size"
              @click="selectedSize=size"
            />
          </div>
        </div>
        <div class="column q-mt-xl">
          <p class="text-weight-medium">AVAILABLE COLORS</p>
          <div class="row">
            <q-btn
              v-for="color in availableColors"
              :key="color"
              outline
              class="grid-style-transition"
              :class="selectedColor==color ? 'bg-grey-3' : ''"
              style="color: goldenrod;"
              :style="selectedColor ==color  ? 'transform: scale(0.95);' : ''"
              :label="color"
              @click="selectedColor=color"
              :disable="!product.preferences.find(item=> item.size==selectedSize && item.color==color)"
            />
          </div>
        </div>
        <div class="column q-mt-xl">
          <p class="text-weight-medium">DESCRIPTION</p>
          <p class="text-body2 text-weight-light">{{product.description}}</p>
        </div>
        <div class="row q-mt-xl">
          <q-btn
            class="q-mb-lg"
            @click="addToCart()"
            unelevated
            color="primary"
            label="ADD TO CART"
          />

          <q-btn
            style="margin-left:30px "
            class="q-mb-lg"
            @click="prompt"
            unelevated
            color="secondary"
            label="ADD REVIEW"
          />
        </div>
        <q-list>
          <div v-for="review in product.reviews" :key="review.id">
            <q-separator spaced inset />

            <q-item>
              <q-item-section>
                <q-item-label>{{review.user.firstName}} {{review.user.lastName}}</q-item-label>
                <q-item-label caption>{{review.text}}</q-item-label>
              </q-item-section>
            </q-item>
          </div>
        </q-list>
      </div>
    </div>
  </div>
</template>
<script>
export default {
  name: "product",
  data() {
    return {
      loaded: false,
      isAdded: false,
      product: {},
      reviewDialog: false,
      cartProducts: [],
      selectedSize: "",
      selectedColor: "",
    };
  },
  async mounted() {
    var interval = setInterval(() => {
      if (this.products.length > 0) {
        this.product = this.products.find(
          (item) => item.id == this.$route.params.product
        );

        if (!this.product) this.$router.push({ name: "notFound" });
        else this.loaded = true;
        clearInterval(interval);
      }
    }, 500);
  },
  methods: {
    prompt() {
      this.$q
        .dialog({
          title: `Review pentru ${this.product.name}`,
          message: "Introduceti un review de minim 3 caractere",
          prompt: {
            model: "",
            isValid: (val) => val.length > 2, // << here is the magic
            type: "text", // optional
          },
          cancel: true,
          persistent: true,
        })
        .onOk((data) => {
          this.$axios
            .post("/api/products/reviews", {
              text: data,
              productId: this.product.id,
            })
            .then((response) => {
              this.$q.notify({
                message: response.data.message,
                color: "positive",
              });
              this.$store.dispatch("adminData/loadProducts");
              var interval = setInterval(() => {
                if (this.products.length > 0) {
                  this.product = this.products.find(
                    (item) => item.id == this.$route.params.product
                  );

                  if (!this.product) this.$router.push({ name: "notFound" });
                  else this.loaded = true;
                  clearInterval(interval);
                }
              }, 500);
            })
            .catch((err) => {
              if (err.response.status == 403) {
                this.$q.notify({
                  color: "negative",
                  message: "Login first",
                  icon: "report_problem",
                });
              } else
                this.$q.notify({
                  color: "negative",
                  message: err.response.data.message,
                  icon: "report_problem",
                });
            });
        });
    },
    addToCart() {
      const selectedProduct = this.product.preferences.find(
        (item) =>
          item.color == this.selectedColor && item.size == this.selectedSize
      );
      if (selectedProduct) {
        const updatedShoppingCart = [...this.shoppingCart];
        const foundItem = this.shoppingCart.find(
          (item) => item.id == selectedProduct.id
        );

        if (foundItem) {
          foundItem.quantity += 1;
        } else {
          updatedShoppingCart.push({
            id: selectedProduct.id,
            quantity: 1,
          });
        }
        this.$axios
          .put("/api/purchases/cart", { items: updatedShoppingCart })
          .then((response) => {
            this.$q.notify({
              message: response.data.message,
              color: "positive",
            });
            this.$store.dispatch("adminData/loadShoppingCart");
          })
          .catch((err) => {
            if (err.response.status == 403) {
              this.$q.notify({
                color: "negative",
                message: "Login first",
                icon: "report_problem",
              });
            } else
              this.$q.notify({
                color: "negative",
                message: err.response.data.message,
                icon: "report_problem",
              });
          });
      } else
        this.$q.notify({
          message: "Nu ai ales culoarea sau marimea",
          color: "negative",
        });
    },
  },
  computed: {
    sizes() {
      return this.$store.getters["adminData/getSizes"];
    },
    products() {
      return this.$store.getters["adminData/getProducts"];
    },
    shoppingCart() {
      return this.$store.getters["adminData/getShoppingCart"].map((item) => ({
        id: item.preference.id,
        quantity: item.quantity,
      }));
    },
    availableSizes() {
      return [...new Set(this.product.preferences.map((item) => item.size))];
    },
    availableColors() {
      return [...new Set(this.product.preferences.map((item) => item.color))];
    },
  },
};
</script>
<style lang="scss" scoped>
.sizes {
  border: 1px solid rgba(129, 128, 120, 0.4);
  width: 30px;
  height: 30px;
  p {
    text-align: center;
    vertical-align: middle;
  }
}
.grid-style-transition {
  transition: transform 0.28s, background-color 0.28s;
}
.margin-lg {
  margin-bottom: 100px;
}
</style>
